<#setting number_format="#">
[
    {
        "angle":45,
        "position":{
            "x":230,
            "y":-110
        },
        "size":{
            "width":45,
            "height":45
        },
        "attrs":{
            "text":{
                "textWrap":{
                    "text": "${moduleName?js_string}",
                    "code":"abstractModule"
                },
                "transform":"rotate(-45deg)"
            },
            "body":{
                "stroke":"${stroke?string}",
                "fill":"${fill?string}",
                "rx":4,
                "ry":4
            },
            "edit-text":{
                "title": "${moduleName?js_string}",
                "style":{
                    "transform":"rotate(-45deg)"
                }
            },
            "shape":{
                "0":"r",
                "1":"h",
                "2":"o",
                "3":"m",
                "4":"b",
                "5":"u",
                "6":"s"
            }
        },
        "shape":"block",
        "ports":{
            "groups":{
                "top":{
                    "position":"top",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "right":{
                    "position":"right",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "bottom":{
                    "position":"bottom",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "left":{
                    "position":"left",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                }
            },
            "items":[
                {
                    "group":"top",
                    "id":"f34c977a-40bd-4e29-a4bd-cc9739523125"
                },
                {
                    "group":"right",
                    "id":"59139553-6c98-408d-9963-226dac5a1823"
                },
                {
                    "group":"bottom",
                    "id":"6c146385-3659-4b2b-b7ce-25df6303feec"
                },
                {
                    "group":"left",
                    "id":"133aaf53-ac01-44ea-9000-705aa6cf58eb"
                }
            ]
        },
        "id":"${startId}",
        "needConfig":${needConfig?number},
        "needRename":${needRename?number},
        "formConfig":${formConfig?string},
        "other":${other?string},
        "originName":"${originName?js_string}",
        "zIndex":5
    },

    <#list nodes as node>
    {
        "position":{
            "x":${node.coordinateOffset + 170},
            "y":60
        },
        "size":{
            "width":68,
            "height":36
        },
        "attrs":{
            "text":{
                "textWrap":{
                    "text":"${node.nodeName?js_string}",
                    "code":"abstractModuleNode"
                }
            },
            "body":{
                "stroke":"#101010",
                "fill":"#FDF5E6",
                "rx":4,
                "ry":4,
                "strokeDasharray":5
            },
            "edit-text":{
                "title":"抽象单元"
            },
            "shape":{
                "0":"r",
                "1":"e",
                "2":"c",
                "3":"t",
                "4":"a",
                "5":"n",
                "6":"g",
                "7":"l",
                "8":"e"
            }
        },
        "shape":"block",
        "ports":{
            "groups":{
                "top":{
                    "position":"top",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "right":{
                    "position":"right",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "bottom":{
                    "position":"bottom",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "left":{
                    "position":"left",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                }
            },
            "items":[
                {
                    "group":"top",
                    "id":"${node.nodeTopId}"
                },
                {
                    "group":"right",
                    "id":"${node.nodeRightId}"
                },
                {
                    "group":"bottom",
                    "id":"${node.nodeBottomId}"
                },
                {
                    "group":"left",
                    "id":"${node.nodeLeftId}"
                }
            ]
        },
        "id":"${node.nodeId}",
        "needConfig":1,
        "needRename":0,
        "formConfig":[
            {
                "hidden" : true,
                "name":"parentNodeId",
                "label":"父节点id",
                "type":"input",
                "value":"${node.parentNodeId}",
                "required":true
            },
            {
                "name":"paramsType",
                "label":"描述",
                "type":"textarea",
                "disabled" : true,
                "value":"${node.desc?js_string}"
            },
            {
                "defaultVarFrom":"paramsKey",
                "jsonTipConfig":{
                    "sources":[
                        "vars"
                    ],
                    "tipWords":[
                        "String",
                        "Integer",
                        "Long"
                    ]
                },
                "funcDict":true,
                "name":"dataHandle",
                "hasVar":true,
                "bottomRightTip":"变量",
                "label":"mock数据",
                "type":"jsonarea",
                "required":true,
                "varWrappedBy":"returnKey",
                "height":200,
                "_valueErr_":false,
                "value":"${node.mock?js_string}",
                "_asyncChkTime_":1666092979621,
                 "disabled" : true,
                "_errAnnotation_":null
            }
        ],
        "other":{
            "canMakeVar":0,
            "course":{
                "article":[
                    {
                        "path":"https://www.yuque.com/ww7anm/ew11t2/ggpq4q#DldYF",
                        "title":"用if else实现买菜"
                    }
                ]
            },
            "needFun":0,
            "example":"{\n   \"expression\" : \"temp.total>240\"\n}\n支持：>,<,>=,<=,==,!=,indexOf,indexOf,startsWith,endsWith,is null,is not null\n"
        },
        "originName":"${node.nodeName?js_string}",
        "zIndex":6
    },
    </#list>

    {
        "angle":45,
        "position":{
            "x":247.31980515339467,
            "y":240
        },
        "size":{
            "width":45,
            "height":45
        },
        "attrs":{
            "text":{
                "textWrap":{
                    "text":"${moduleName?js_string}结束",
                    "code":"abstractModule end"
                },
                "transform":"rotate(-45deg)"
            },
            "body":{
                "stroke":"#B89696",
                "fill":"#FBE6E6",
                "rx":4,
                "ry":4
            },
            "edit-text":{
                "title":"${moduleName?js_string}结束",
                "style":{
                    "transform":"rotate(-45deg)"
                }
            },
            "shape":{
                "0":"r",
                "1":"h",
                "2":"o",
                "3":"m",
                "4":"b",
                "5":"u",
                "6":"s"
            }
        },
        "shape":"block",
        "ports":{
            "groups":{
                "top":{
                    "position":"top",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "right":{
                    "position":"right",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "bottom":{
                    "position":"bottom",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                },
                "left":{
                    "position":"left",
                    "attrs":{
                        "circle":{
                            "r":5,
                            "magnet":true,
                            "stroke":"#5F95FF",
                            "strokeWidth":1,
                            "fill":"#fff",
                            "style":{
                                "visibility":"hidden"
                            }
                        }
                    }
                }
            },
            "items":[
                {
                    "group":"top",
                    "id":"6409fdb6-a7a5-42d9-8ee6-8b0245da0ea4"
                },
                {
                    "group":"right",
                    "id":"34fb4208-4ac0-4828-9009-85403de167bb"
                },
                {
                    "group":"bottom",
                    "id":"065af54c-993e-44a1-aaf9-9200319c4c6f"
                },
                {
                    "group":"left",
                    "id":"505d4e1d-c951-4a29-9cc3-bcd832552fcd"
                }
            ]
        },
        "id":"${endId}",
        "needConfig":0,
        "needRename":0,
        "formConfig":[

        ],
        "other":{
            "canMakeVar":0,
            "course":{

            },
            "needFun":1,
            "example":null
        },
        "originName":"${moduleName?js_string}结束",
        "zIndex":7
    },

    <#list nodes as node>
    {
        "shape":"edge",
        "attrs":{
            "line":{
                "stroke":"#3a87ad",
                "strokeWidth":1,
                "targetMarker":{
                    "name":"classic",
                    "size":8
                }
            }
        },
        "id":"${node.edgeIdF}",
        "router":{
            "name":"manhattan"
        },
        "connector":{
            "name":"rounded",
            "args":{

            }
        },
        "zIndex":0,
        "source":{
            "cell":"${startId}",
            "port":"6c146385-3659-4b2b-b7ce-25df6303feec"
        },
        "target":{
            "cell":"${node.nodeId}",
            "port":"${node.nodeTopId}"
        }
    },
    {
        "shape":"edge",
        "attrs":{
            "line":{
                "stroke":"#3a87ad",
                "strokeWidth":1,
                "targetMarker":{
                    "name":"classic",
                    "size":8
                }
            }
        },
        "id":"${node.edgeIdS}",
        "router":{
            "name":"manhattan"
        },
        "connector":{
            "name":"rounded",
            "args":{

            }
        },
        "zIndex":0,
        "source":{
            "cell":"${node.nodeId}",
            "port":"${node.nodeBottomId}"
        },
        "target":{
            "cell":"${endId}",
            "port":"505d4e1d-c951-4a29-9cc3-bcd832552fcd"
        }
    }
    <#if node_has_next>,</#if>
    </#list>
]